# coding: utf-8

"""
    Visier Analytic Model APIs

    Visier APIs for retrieving and configuring your analytic model in Visier.

    The version of the OpenAPI document: 22222222.99201.1905
    Contact: alpine@visier.com

    Please note that this SDK is currently in beta.
    Functionality and behavior may change in future releases.
    We encourage you to provide feedback and report any issues encountered during your use.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from visier_api_analytic_model.models.designer_api_dimension_member_dto import DesignerApiDimensionMemberDTO
from typing import Optional, Set
from typing_extensions import Self

class DesignerApiDimensionFilterDTO(BaseModel):
    """
    DesignerApiDimensionFilterDTO
    """ # noqa: E501
    dimension_id: Optional[StrictStr] = Field(default=None, description="The UUID of the dimension.", alias="dimensionId")
    symbol_name: Optional[StrictStr] = Field(default=None, description="The symbol name of the dimension.", alias="symbolName")
    dimension_members: Optional[List[DesignerApiDimensionMemberDTO]] = Field(default=None, description="A list of dimension members to map to the perspective node.   Note: If this array is empty, all dimension members will be removed for the node.", alias="dimensionMembers")
    __properties: ClassVar[List[str]] = ["dimensionId", "symbolName", "dimensionMembers"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DesignerApiDimensionFilterDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in dimension_members (list)
        _items = []
        if self.dimension_members:
            for _item_dimension_members in self.dimension_members:
                if _item_dimension_members:
                    _items.append(_item_dimension_members.to_dict())
            _dict['dimensionMembers'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DesignerApiDimensionFilterDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dimensionId": obj.get("dimensionId"),
            "symbolName": obj.get("symbolName"),
            "dimensionMembers": [DesignerApiDimensionMemberDTO.from_dict(_item) for _item in obj["dimensionMembers"]] if obj.get("dimensionMembers") is not None else None
        })
        return _obj


