# coding: utf-8

"""
    Visier Analytic Model APIs

    Visier APIs for retrieving and configuring your analytic model in Visier.

    The version of the OpenAPI document: 22222222.99201.1905
    Contact: alpine@visier.com

    Please note that this SDK is currently in beta.
    Functionality and behavior may change in future releases.
    We encourage you to provide feedback and report any issues encountered during your use.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from visier_api_analytic_model.models.servicing_v2_objectconfiguration_execution_context_dto import ServicingV2ObjectconfigurationExecutionContextDTO
from typing import Optional, Set
from typing_extensions import Self

class ServicingV2ObjectconfigurationFailedChangeDTO(BaseModel):
    """
    ServicingV2ObjectconfigurationFailedChangeDTO
    """ # noqa: E501
    execution_context: Optional[ServicingV2ObjectconfigurationExecutionContextDTO] = Field(default=None, description="The tenant and, optionally, project that change was attempted on.", alias="executionContext")
    object_name: Optional[StrictStr] = Field(default=None, description="The object name of the object that was attempted to be changed.", alias="objectName")
    uuid: Optional[StrictStr] = Field(default=None, description="The UUID of the object that was attempted to be changed.")
    display_name: Optional[StrictStr] = Field(default=None, description="The display name of the object that was attempted to be changed.", alias="displayName")
    messages: Optional[List[StrictStr]] = Field(default=None, description="The error messages.")
    __properties: ClassVar[List[str]] = ["executionContext", "objectName", "uuid", "displayName", "messages"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ServicingV2ObjectconfigurationFailedChangeDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of execution_context
        if self.execution_context:
            _dict['executionContext'] = self.execution_context.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ServicingV2ObjectconfigurationFailedChangeDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "executionContext": ServicingV2ObjectconfigurationExecutionContextDTO.from_dict(obj["executionContext"]) if obj.get("executionContext") is not None else None,
            "objectName": obj.get("objectName"),
            "uuid": obj.get("uuid"),
            "displayName": obj.get("displayName"),
            "messages": obj.get("messages")
        })
        return _obj


